//---------------------------------------------------
// module  : FMBFM.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

#ifndef FMBFM_H
#define FMBFM_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionFMBFM.h"

//------------------------------------------------
// CONSTANTES  -----------------------------------
//------------------------------------------------

//>MODEL SEGMENTATIONS
const int NBSPCOL=12;

const int NBCL1=10;
const int NBCL2=9;
const int NBCL3=4;

const int NBINS=5;
const int SIZE1=7;
const int SIZEMIN=200;

//>MODEL FUSION
const int NBITERICM=12;
const float ALPHA=0.86;
const float TAU=16.0;
const int PRECIS=1;

//>MODEL VISU
const int ZOOM=1;
const int QUIT=0;
const int SAVE=1;
const int VISU=1;


//------------------------------------------------
// CLASSE FMFBM ----------------------------------
//------------------------------------------------
class FMBFM
{
  //--Donnees--
  //-----------
  public:

  //Matrices Img
  int***    mat_img;
  int***    mat_cnt;
  float**   mat_seg; 

  //ParamIMG
  int width,length;

  //Flag
  int  flag_save;
  int  flag_visu;

  //Utile
  char Name_Sauve[NCHAR];
  char Name_Img[NCHAR];
  char Extension[NCHAR];  

  //--Methodes--
  //------------
  public:
  FMBFM(int***,int,int);
  ~FMBFM();

  //Fonction
  void MultipleSegmentations(int***,int,int,int,int);
 
  //Fusion-Fmeasure
  void FMeasureFusionModel();

  //Tests
  void Test_SoftCont_FusionModel();
  //====================================
  
};

#endif 
